Status: Closed

Priority: Normal

Assignee:

Category: Python plugins

Affected QGIS version:master Regression?: No
Operating System: Windows Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corruptsdata: Copied to github as #: 16442
Description

Hi, i tried to add a comma-separated file (csv) as table to QGIS.
The following example works without issues on Linux systems (QGIS dev):

fileName = vectorPath # the path to the csv
fileInfo = QFilelnfo(fleName)
baseName = fileInfo.oaseName()
uri = fileName+"?delimiter=%s" % (";") # ; as seperator
vlayer = QgsVectorLayer(uri, baseName, "delimitedtext")
if not vliayer.isValid():
QMessageBox.warning(QDialog(),"Warning","Failed to add the Layer to QGis")
QgsMapLayerRegistry.instance().addMapLayer(vlayer)

However using QGIS dev on Windows XP always results in an invalid layer ("Failed to add the Layer to QGIS"), while QGIS 1.8 simply
crashes ("Error Message: QGIS.bin has to be closed").
Did i stumble upon a bug or is the procedure to add tables to QGIS different on Windows systems?

History

#1 - 2013-04-02 12:28 PM - Jiirgen Fischer

Did you enable the delimited text plugin?

#2 - 2013-04-02 02:00 PM - Martin Jung
No, i didn't before.
| just tested it and it has no influence on the errors (QGIS 1.8 still crashing on WIN XP -> qgis.exe has found an Error | QGIS dev returns the messagebox
that the layer is not valid.)
#3 - 2013-04-02 05:24 PM - Jiirgen Fischer
Martin Jung wrote:
No, i didn't before.

1 just tested it and it has no influence on the errors (QGIS 1.8 still crashing on WIN XP -> qgis.exe has found an Error | QGIS dev returns the
messagebox that the layer is not valid.)
use uri = "file:/"+fileName+"?delimiter=%s" % (";") # ; as seperator

#4 - 2013-04-03 12:58 AM - Martin Jung
- Status changed from Open to Closed

Ahh, that fixed it. Thanks!

#5 - 2013-04-15 05:26 PM - Chris Crook

One safe way of building the url for the delimited text plugin is to use QUrl...

url = QUrl.fromLocalFile(filename)
url.addQueryltem('delimiter',’;')
url.addQueryltem('xField','longitude’)
url.addQueryltem('yField', latitude’)
layer_uri=QString.fromAscii(url.toEncoded())
vlayer=QgsVectorLayer(layer_uri,"My layer","delimitedtext")
